/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor. 
 */
package binarisrendezes;

/* Példa fa-struktúra felépítésére, bejárására */

public class FaDemo {

    public void indit() {

        int i;
        int tomb[] = new int[]{5, 1, 8, 6, 3, 9};
        System.out.println("A számok eredeti sorrendje: ");

        for (i = 0; i < tomb.length; i++) {
            System.out.println(tomb[i]);
        }

        BinarisFa fa = new BinarisFa(tomb[0]);

        for (i = 1; i < tomb.length; i++) {
            beszur(fa, tomb[i]);
        }

        System.out.println("\nA fa létrehozása utáni sorrend:");
        bejar(fa);
    }

    public void beszur(BinarisFa fa, int adat) {
        if (adat < fa.getGyoker()) {
            if (fa.getBal() != null) {
                beszur(fa.getBal(), adat);
            } else {
                System.out.println("Beszúrtam " + adat + "-t "
                        + fa.getGyoker() + " bal oldalára");
                fa.setBal(new BinarisFa(adat));
            }
        } else {
            if (fa.getJobb() != null) {
                beszur(fa.getJobb(), adat);
            } else {
                System.out.println("Beszúrtam " + adat + "-t "
                        + fa.getGyoker() + " jobb oldalára");
                fa.setJobb(new BinarisFa(adat));
            }
        }
    }

    public void bejar(BinarisFa fa) {
        if (fa != null) {
            bejar(fa.getBal());
            System.out.println(fa.getGyoker());
            bejar(fa.getJobb());
        }
    }
}